Attribute VB_Name = "MailMessagesToExcel"
Option Explicit

Private strTemplatesPath As String


Public Sub SaveMessagesToExcel()
'Created by Helen Feddema 5-Sep-2007
'Last modified 5-Sep-2007
'Demonstrates pushing mail message data to rows in an Excel worksheet

On Error GoTo ErrorHandler

   Dim appExcel As New Excel.Application
   Dim wkb As Excel.Workbook
   Dim wks As Excel.Worksheet
   Dim rng As Excel.Range
   Dim strSheet As String
   Dim i As Integer
   Dim j As Integer
   Dim lngCount As Long
   Dim msg As Outlook.MailItem
   Dim nms As Outlook.NameSpace
   Dim fld As Outlook.MAPIFolder
   'Must declare as Object because folders may contain different
   'types of items
   Dim itm As Object
   Dim strTitle As String
   Dim strPrompt As String

   strTemplatesPath = GetTemplatesPath
   strSheet = "Messages.xls"
   strSheet = strTemplatesPath & strSheet
   Debug.Print "Excel workbook: " & strSheet

   'Test for file in the Templates folder
   If TestFileExists(strSheet) = False Then
      strTitle = "Worksheet file not found"
      strPrompt = strSheet & _
         " not found; please copy Messages.xls to this folder and try again"
      MsgBox strPrompt, vbCritical + vbOKOnly, strTitle
      GoTo ErrorHandlerExit
   End If
   
   Set wkb = appExcel.Workbooks.Open(strSheet)
   Set wks = wkb.Sheets(1)
   wks.Activate
   appExcel.Application.Visible = True

   'Let user select a folder to export
   On Error Resume Next
   
SelectMailFolder:
      Set fld = nms.PickFolder
      Debug.Print "Folder item type: " & fld.DefaultItemType

      If fld Is Nothing Then
         GoTo ErrorHandlerExit
      ElseIf fld.DefaultItemType <> olMailItem Then
         strPrompt = "Please select a Mail folder"
         strTitle = "Folder error"
         MsgBox prompt:=strPrompt, _
            Buttons:=vbExclamation + vbOKOnly, _
            Title:=strTitle
         GoTo SelectMailFolder
      End If
   
On Error GoTo ErrorHandler
   
   lngCount = fld.Items.Count
   
   If lngCount = 0 Then
      MsgBox "No messages to export"
      GoTo ErrorHandlerExit
   Else
      Debug.Print lngCount & " messages to export"
   End If

   'Adjust i (row number) to be 1 less than the number of the first body row
   i = 3
   
  'Iterate through contact items in Contacts folder, and export a few fields
   'from each item to a row in the Contacts worksheet
   For Each itm In fld.Items
      If itm.Class = olMail Then
         'Process item only if it is a mail item
         Set msg = itm
         i = i + 1
         
         'j is the column number
         j = 1
      
         Set rng = wks.Cells(i, j)
         If msg.To <> "" Then rng.Value = msg.To
         j = j + 1
         
         Set rng = wks.Cells(i, j)
         If msg.cc <> "" Then rng.Value = msg.cc
         j = j + 1
         
         Set rng = wks.Cells(i, j)
         If msg.SenderEmailAddress <> "" Then rng.Value = msg.SenderEmailAddress
         j = j + 1
         
         Set rng = wks.Cells(i, j)
         If msg.Subject <> "" Then rng.Value = msg.Subject
         j = j + 1
         
         Set rng = wks.Cells(i, j)
         rng.Value = msg.SentOn
         j = j + 1
         
         Set rng = wks.Cells(i, j)
         rng.Value = msg.ReceivedTime
         
         j = j + 1
         
         Set rng = wks.Cells(i, j)
         If msg.Categories <> "" Then rng.Value = msg.Categories
         j = j + 1
         
         Set rng = wks.Cells(i, j)
         On Error Resume Next
         'The next line illustrates the syntax for referencing
         'a custom Outlook field
         If msg.UserProperties("CustomField") <> "" Then
            rng.Value = msg.UserProperties("CustomField")
         End If
         j = j + 1
      End If
   Next itm

ErrorHandlerExit:
   Exit Sub

ErrorHandler:
   MsgBox "Error No: " & Err.Number _
      & " in SaveMessagesToExcel procedure; " _
      & "Description: " & Err.Description
   Resume ErrorHandlerExit

End Sub

Public Function TestFileExists(strFile As String) As Boolean
'Created by Helen Feddema 9-1-2004
'Last modified 9-1-2004
'Tests for existing of a file, using the FileSystemObject
   
   Dim fso As New Scripting.FileSystemObject
   Dim fil As Scripting.File
   
On Error Resume Next

   Set fil = fso.GetFile(strFile)
   If fil Is Nothing Then
      TestFileExists = False
   Else
      TestFileExists = True
   End If
   
End Function

Public Function GetTemplatesPath() As String
'Created by Helen Feddema 5-Sep-2007
'Last modified 5-Sep-2007
   
   Dim appWord As Word.Application
   Set appWord = GetObject(, "Word.Application")
   
   strTemplatesPath = _
      appWord.Options.DefaultFilePath(wdUserTemplatesPath) & "\"
   Debug.Print "Templates folder: " & strTemplatesPath
   GetTemplatesPath = strTemplatesPath
   
ErrorHandlerExit:
   Set appWord = Nothing
   Exit Function

ErrorHandler:
   If Err = 429 Then
      'Word is not running; open Word with CreateObject
      Set appWord = CreateObject("Word.Application")
      Resume Next
   Else
      MsgBox "Error No: " & Err.Number & "; Description: " _
         & Err.Description
      Resume ErrorHandlerExit
   End If

End Function
